#!/bin/sh

# we indicate where the velocity files are stored
dir_save="/toon/usr/deloncle/temp_post_traitement/Fh0.33_Re3000/stride_256x256x36"

# dimensions of the velocity files
nx=256
ny=256
nz=36
vx_translation=0.3473
vy_translation=0.


#____________________________________________________________
#
#     DO NOT MODIFY BELOW!
#____________________________________________________________
#

printf "\nDirectory: $dir_save\n"

mkdir -p $dir_save/energy_analysis
cp timing.F90 fft.F90 energy_analysis.F90 $dir_save/energy_analysis

cd $dir_save/energy_analysis

# we change the dimensions in the source file
sed -e "s/integer, parameter :: nx=.*/integer, parameter :: nx=$nx/" \
    -e "s/integer, parameter :: ny=.*/integer, parameter :: ny=$ny/" \
    -e "s/integer, parameter :: nz=.*/integer, parameter :: nz=$nz/" \
    -e "s/double precision, parameter :: vx_translation=.*/double precision, parameter :: vx_translation=$vx_translation/" \
    -e "s/double precision, parameter :: vy_translation=.*/double precision, parameter :: vy_translation=$vy_translation/" \
    energy_analysis.F90 > energy_analysis.F90_bis

mv energy_analysis.F90_bis energy_analysis.F90

# compilation
printf "\nCompilation of the Fortran code...\n\n"
ifort -DFFTW -O3 timing.F90 fft.F90 energy_analysis.F90 -o energy_analysis.out -convert big_endian -L/moogwai/usr/deloncle/lib_fftw/lib_fftw_linux64/lib/ -lfftw3 -lm
chmod 744 energy_analysis.out

# we copy the executable in the data files directory
mv energy_analysis.out ../
cd ../

# we print the list of the original velocity files
ls -1 velo_rho_vort.t=*  > list_data_file_names

echo "list_data_file_names" | nice -15 ./energy_analysis.out
                                                                  
mv dissipation.t=* R.t=* dudz_dvdz_drhodz.t=* energy_analysis.out list_data_file_names energy_analysis_results energy_analysis

exit
