% ce script permet de lire les resultats de la determination de l'energie cinetique, potentielle et de l'enstrophie
% dans chacune des couches horizontales

plot_all=0;


if strcmp('PCWIN', computer)
	ls('.');
else
	system(['ls -t ', '.']);
end

% file_name = input('Energy analysis file to use: ', 's');
file_name='energy_analysis_results';

% on commence par essayer en little-endian (PC)
type_endian = 'ieee-le';
FID = fopen(file_name, 'r',type_endian);
poub = fread(FID, 1, 'integer*4');
flag = fread(FID, 1, 'integer*4');
status = fclose(FID);

% si le flag est different de 1, on essaye le big-endian (SGI, NEC, IBM)
if flag ~= 1
    type_endian = 'ieee-be';
    FID = fopen(file_name, 'r',type_endian);
    poub = fread(FID, 1, 'integer*4');
    flag = fread(FID, 1, 'integer*4');
    status = fclose(FID);

    % on verifie que le flag vaut bien 1 cette fois-ci
    if flag ~= 1
        fprintf(1, '\n Il y a un probleme dans le format du fichier : le flag est different de 1\n');
        return
    end
end

% on lit toutes les metadonnees
FID = fopen(file_name, 'r',type_endian);

poub            = fread(FID, 1, 'integer*4');
flag            = fread(FID, 1, 'integer*4');
nx              = fread(FID, 1, 'integer*4');
ny              = fread(FID, 1, 'integer*4');
nz              = fread(FID, 1, 'integer*4');
lx              = fread(FID, 1, 'real*8');
ly              = fread(FID, 1, 'real*8');
lz              = fread(FID, 1, 'real*8');
nu              = fread(FID, 1, 'real*8');
xns				= fread(FID, 1, 'real*8');
schm			= fread(FID, 1, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
nb_file         = fread(FID, 1, 'integer*4');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
instants        = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
energy_h        = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
energy_v        = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
energy_t        = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
potential_energy= fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_h     = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_v     = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_t     = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
R               = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
R_tilde         = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
dissipation     = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
dissipation2    = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
diffusion_rho   = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_stretching   = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_barocline = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_viscous = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_h_stretching   = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_h_tilting = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_h_barocline = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_h_viscous = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_z_stretching   = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_z_tilting = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
enstrophy_z_viscous = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

status = fclose(FID);

if (plot_all==1)

%figure(1)
%hold on
%plot(instants, energy_t, instants, energy_h, '--', instants, energy_v, '--', instants, potential_energy)
%legend('energy_t', 'energy_h', 'energy_v', 'potential energy')

figure(1)
hold on
plot(instants, energy_t,'r*')

figure(2)
hold on
plot(instants, enstrophy_h, instants, enstrophy_v, instants, enstrophy_t)
legend('enstrophy_h', 'enstrophy_v', 'enstrophy_t')

figure(21)
subplot(1,2,1)
hold on
plot(instants, 0.57*enstrophy_t/lz, 'g')


subplot(1,2,2)
hold on
% on calcule le Reynolds
Re=2./(pi*nu)
plot(instants, 0.57*enstrophy_t/(Re*lz), 'g')



%figure(3)
%plot(instants, R)
%legend('R')

figure(4)
plot(instants, R_tilde)
legend('R_{tilde}')

figure(5)
plot(instants, sqrt(energy_h./enstrophy_h))
legend('L_v')


figure(6)
plot(instants, enstrophy_stretching, instants, enstrophy_barocline, instants, enstrophy_viscous)
legend('enstrophy_{stretching}', 'enstrophy_{barocline}', 'enstrophy_{viscous}')

figure(61)
plot(instants, enstrophy_h_stretching, instants, enstrophy_h_tilting, instants, enstrophy_h_viscous, instants, enstrophy_h_barocline)
legend('enstrophy h_{stretching}', 'enstrophy h_{tilting}', 'enstrophy h_{viscous}', 'enstrophy h_{barocline}')

figure(62)
plot(instants, enstrophy_z_stretching, instants, enstrophy_z_tilting, instants, enstrophy_z_viscous)
legend('enstrophy z_{stretching}', 'enstrophy z_{tilting}', 'enstrophy z_{viscous}')

figure(63)
plot(instants, enstrophy_z_tilting, instants, -enstrophy_h_tilting,'--')
legend('enstrophy z_{tilting}', '-enstrophy h_{tilting}')

figure(64)
plot(instants, enstrophy_stretching, instants, enstrophy_h_stretching+enstrophy_z_stretching,'--')
legend('enstrophy_{stretching}', 'enstrophy h_{stretching}+enstrophy z_{stretching}')

figure(65)
plot(instants, enstrophy_viscous, instants, enstrophy_h_viscous+enstrophy_z_viscous,'--')
legend('enstrophy_{viscous}', 'enstrophy h_{viscous}+enstrophy z_{viscous}')

% on compare la variation d'energie cinetique + energie potentielle avec les termes
% de diffusion de densite et de dissipation visqueuse
figure(7)
dEdt = diff(energy_t+potential_energy)./diff(instants);
dEdt = [dEdt(1); dEdt];
plot(instants, dEdt, instants, -dissipation, '--g', instants, -dissipation + diffusion_rho, 'r')
legend('d(E_c+E_p)dt', '-Dissipation', '-Dissipation + diffusion_{rho}')

figure(71)
plot(instants, -dissipation, '-k', instants, diffusion_rho, '--k')
legend('-Dissipation', 'diffusion_{rho}')


% on compare la variation d'enstrophie avec ses differents termes constituants
% de diffusion de densite et de dissipation visqueuse
figure(8)
dZdt = diff(enstrophy_t)./diff(instants);
dZdt = [dZdt(1); dZdt];
plot(instants, dZdt, instants,enstrophy_stretching+enstrophy_barocline+enstrophy_viscous)
legend('dZdt', 'enstrophy_{reorientation} + enstrophy_{barocline} + enstrophy_{viscous}')

% on compare les differentes expressions de la dissipation totale
figure(9)
plot(instants, dissipation, instants, dissipation2, '*g', instants, 2*nu*enstrophy_t,'--r')
legend('2*\int\nu d:d d\tau', '-\nu*\int u \nabla u d\tau', '2* \nu * Z')
title('Comparaison differentes expressions Dissipation totale')


% on compare la variation d'energie cinetique + energie potentielle avec les termes
% de diffusion de densite et de dissipation visqueuse
figure(10)
dEcdt = diff(energy_t)./diff(instants);
dEcdt = [dEcdt(1); dEcdt];
dEpdt = diff(potential_energy)./diff(instants);
dEpdt = [dEpdt(1); dEpdt];
plot(instants, dEcdt,instants, dEcdt+dissipation, '--', instants, dEpdt)
legend('dE_cdt', 'dE_cdt+Dissipation', 'dE_pdt')

end
