#!/bin/sh

# we indicate where the velocity files are stored
dir_save="/toon/usr/deloncle/NS3D_results/ns3d_contrarotating_768x768x192_L=2.1x2.1x0.57_Dt=0.00125_nu=5E-5_N=12._brodie_13-11-06_11h49_pid1308/stride_128x128x96"

# dimensions of the velocity files
nx=128
ny=128
nz=96
vx_translation=0.34
vy_translation=0.


#____________________________________________________________
#
#     DO NOT MODIFY BELOW!
#____________________________________________________________
#

printf "\nDirectory: $dir_save\n"

cp timing.F90 energy_slice.F90 $dir_save

cd $dir_save

# we change the dimensions in the source file
sed -e "s/integer, parameter :: nx=.*/integer, parameter :: nx=$nx/" \
    -e "s/integer, parameter :: ny=.*/integer, parameter :: ny=$ny/" \
    -e "s/integer, parameter :: nz=.*/integer, parameter :: nz=$nz/" \
    -e "s/double precision, parameter :: vx_translation=.*/double precision, parameter :: vx_translation=$vx_translation/" \
    -e "s/double precision, parameter :: vy_translation=.*/double precision, parameter :: vy_translation=$vy_translation/" \
    energy_slice.F90 > energy_slice.F90_bis

mv energy_slice.F90_bis energy_slice.F90

# compilation
printf "\nCompilation of the Fortran code...\n"
ifort -O3 timing.F90 energy_slice.F90 -o energy_slice -convert big_endian
chmod 744 energy_slice

# we print the list of the original velocity files
ls -1 velo_rho_vort.t=*  > liste_fichiers

echo "liste_fichiers" | ./energy_slice

rm -rf energy_slice *.mod

exit
