% ce script vise a essayer de determiner les caracteristiques du toubillons de Lamb-Oseen (rayon, vorticite)
% s'ajustant au mieux  un champ de vorticite observee.

function [vort_z_theorique] = build_vort_z_theorique3(x_p,y_p,Gamma_p,a_p,b_p,theta_p,x_n,y_n,Gamma_n,a_n,b_n,theta_n,lx,ly,nx,ny)

nb_adjacent = 1;
xx = linspace(0, lx-lx/nx, nx);
yy = linspace(0, ly-ly/ny, ny);

c_p = sqrt(0.5*(a_p^2+b_p^2));
c_n = sqrt(0.5*(a_n^2+b_n^2));

% we determine the square distance of every vortex core to the grid points (xx,yy)
vort_z_theorique = zeros(nx, ny);
for nb_boite_x = -nb_adjacent:nb_adjacent
    for nb_boite_y = -nb_adjacent:nb_adjacent
        for ix=1:ny
            for iy=1:ny
                xx_p = ( (xx(ix) - x_p-nb_boite_x*lx)*cos(theta_p)+(yy(iy) - y_p-nb_boite_y*ly)*sin(theta_p))^2/a_p^2;
                yy_p = (-(xx(ix) - x_p-nb_boite_x*lx)*sin(theta_p)+(yy(iy) - y_p-nb_boite_y*ly)*cos(theta_p))^2/b_p^2;

                xx_n = ( (xx(ix) - x_n-nb_boite_x*lx)*cos(theta_n)+(yy(iy) - y_n-nb_boite_y*ly)*sin(theta_n))^2/a_n^2;
                yy_n = (-(xx(ix) - x_n-nb_boite_x*lx)*sin(theta_n)+(yy(iy) - y_n-nb_boite_y*ly)*cos(theta_n))^2/b_n^2;

                vort_z_theorique(ix,iy) = vort_z_theorique(ix,iy) + Gamma_p/(pi*c_p^2)*exp(-xx_p-yy_p) + Gamma_n/(pi*c_n^2)*exp(-xx_n-yy_n);
            end
    	end
	end
end

pcolor(xx,yy,vort_z_theorique')
shading flat
xlabel('x')
ylabel('y')


