#!/bin/sh

# we indicate where the velocity files are stored
dir_save="/toon/usr/deloncle/NS3D_results/ns3d_contrarotating_768x768x192_L=2.1x2.1x0.57_Dt=0.00125_nu=5E-5_N=12._brodie_13-11-06_11h49_pid1308/stride_128x128x96"

# dimensions of the velocity files
nx=128
ny=128
nz=96

# type of fitting
type_fitting=1


#____________________________________________________________
#
#     DO NOT MODIFY BELOW!
#____________________________________________________________
#

printf "\nDirectory: $dir_save\n"

cp timing.F90 elsunc.f90 char_vortices.F90 $dir_save

cd $dir_save

# we change the dimensions in the source file
sed -e "s/integer, parameter :: nx=.*/integer, parameter :: nx=$nx/" \
    -e "s/integer, parameter :: ny=.*/integer, parameter :: ny=$ny/" \
    -e "s/integer, parameter :: nz=.*/integer, parameter :: nz=$nz/" \
    -e "s/integer :: type_fitting=.*/integer :: type_fitting=$type_fitting/" \
    char_vortices.F90 > char_vortices.F90_bis

mv char_vortices.F90_bis char_vortices.F90

# compilation
printf "\nCompilation of the Fortran code...\n"
ifort -O3 timing.F90 elsunc.f90 char_vortices.F90 -o char_vortices_$type_fitting -convert big_endian
chmod 744 char_vortices_$type_fitting

# we print the list of the original velocity files
ls -1 velo_rho_vort.t=* > liste_fichiers

printf "\nExecution du code...\n"
ulimit -s unlimited
echo "liste_fichiers" | nice -15 ./char_vortices_$type_fitting

rm -rf char_vortices_$type_fitting *.mod

exit
