% ce script permet de lire les resultats de fitting des tourbillons de Lamb-Oseen dans chacune des couches horizontales

if strcmp('PCWIN', computer)
	ls('.');
else
	system(['ls -t ', '.']);
end

file_name = input('Parameters vortex file to use: ', 's');


% on commence par essayer en little-endian (PC)
type_endian = 'ieee-le';
FID = fopen(file_name, 'r',type_endian);
poub = fread(FID, 1, 'integer*4');
flag = fread(FID, 1, 'integer*4');
status = fclose(FID);

% si le flag est different de 1, on essaye le big-endian (SGI, NEC, IBM)
if flag ~= 1
    type_endian = 'ieee-be';
    FID = fopen(file_name, 'r',type_endian);
    poub = fread(FID, 1, 'integer*4');
    flag = fread(FID, 1, 'integer*4');
    status = fclose(FID);

    % on verifie que le flag vaut bien 1 cette fois-ci
    if flag ~= 1
        fprintf(1, '\n Il y a un probleme dans le format du fichier : le flag est different de 1\n');
        return
    end
end


% on lit toutes les metadonnees
FID = fopen(file_name, 'r',type_endian);

poub            = fread(FID, 1, 'integer*4');
flag            = fread(FID, 1, 'integer*4');
nx              = fread(FID, 1, 'integer*4');
ny              = fread(FID, 1, 'integer*4');
nz              = fread(FID, 1, 'integer*4');
lx              = fread(FID, 1, 'real*8');
ly              = fread(FID, 1, 'real*8');
lz              = fread(FID, 1, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
nb_file         = fread(FID, 1, 'integer*4');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
type_fitting    = fread(FID, 1, 'integer*4');
n_fitting       = fread(FID, 1, 'integer*4');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
instants        = fread(FID, nb_file, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
param_vortex_p  = fread(FID, nb_file*nz*n_fitting, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
param_vortex_n  = fread(FID, nb_file*nz*n_fitting, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
erreur_rel      = fread(FID, nb_file*nz, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
code_convergence= fread(FID, nb_file*nz, 'integer*4');
poub            = fread(FID, 1, 'integer*4');

status = fclose(FID);

param_vortex_p  = reshape(param_vortex_p, [nb_file,nz,n_fitting]);
param_vortex_n  = reshape(param_vortex_n, [nb_file,nz,n_fitting]);
erreur_rel  = reshape(erreur_rel, [nb_file,nz]);
code_convergence  = reshape(code_convergence, [nb_file,nz]);

% on cre la grille des points de colocation
X = linspace(0, lx-lx/nx, nx);
Y = linspace(0, ly-ly/ny, ny);
Z = linspace(0, lz-lz/nz, nz);



