# we indicate where the velocity files are stores on gaya
dir_save="/toon/usr/deloncle/NS3D_results/Fh1.33_Re6000/ns3d_contrarotating_384x384x96_L=2.1x2.1x0.57_Dt=0.0025_nu=0.0001_N=12._brodie_13-12-06_23h25_pid12836/stride_128x128x96"

# dimensions of the velocity files and the strides along each directions
nx=128
ny=128
nz=96

#____________________________________________________________
#
#     DO NOT MODIFY BELOW!
#____________________________________________________________
#

printf "\nWorking directory: $dir_save\n"

cp fft_spectral.F90 spectral.F90 $dir_save
cd $dir_save

# we change the dimensions in the source file

# compilation
printf "\nCompilation of the Fortran code...\n"


if [ -n "`echo $HOSTNAME | grep -e raspoutine -e dracula -e joebar`" ]; then
    ifort -r8 -O3 -vec_report0 -warn all fft_spectral.F90 spectral.F90 -o spectral -convert big_endian -assume byterecl -fpp -DDIMX=$nx -DDIMY=$ny -DDIMZ=$nz -DPPADKX=0 -DPPADKY=0 -DPPADKZ=0 -DFFTW -L/moogwai/usr/deloncle/lib_fftw/lib_fftw_linux64/lib/ -lfftw3 -lm
elif [ -n "`echo $HOSTNAME | grep -e tetsuo -e kelvin -e mandrake -e jill -e gailuron`" ]; then
    ifort -r8 -O3 -vec_report0 -warn all fft_spectral.F90 spectral.F90 -o spectral -convert big_endian -assume byterecl -fpp -DDIMX=$nx -DDIMY=$ny -DDIMZ=$nz -DPPADKX=0 -DPPADKY=0 -DPPADKZ=0 -DFFTW -L/moogwai/usr/deloncle/lib_fftw/lib_fftw_linux/lib/ -lfftw3 -lm
fi

chmod 744 spectral

# we get the list of the original velocity files
printf "\nGetting the list of data files...\n"
ls -1 velo_rho_vort.t=* > liste_fichiers.txt

# we remove any previous statistics file
rm -rf spectral_statistics.out

# Copy of each file...
printf "\nRunning the program for each file...\n"
for name in `cat liste_fichiers.txt`; do
	printf "\n    velocity file: $name";
	echo $name | ./spectral;
done

rm -rf spectral fft_spectral.* spectral.* liste_fichiers.txt

exit
